VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DInput_Keyboard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Thomas Geiger

'Diese Klasse ist fr die Abfrage der Tastatur zustndig

Dim DirectX As DirectX7
Dim DInput As DirectInput
Dim DInputDevice As DirectInputDevice
Dim KeyboardState As DIKEYBOARDSTATE

Dim P_Up As Boolean
Dim P_Down As Boolean
Dim P_Right As Boolean
Dim P_Left As Boolean

Const DiKeyUp = 200
Const DiKeyDown = 208
Const DiKeyLeft = 203
Const DiKeyRight = 205
Function ConnectToKeyboard(Form_Val As Form) As Boolean

On Error GoTo inierr

Set DirectX = New DirectX7
Set DInput = DirectX.DirectInputCreate()
Set DInputDevice = DInput.CreateDevice("GUID_SysKeyboard")

   DInputDevice.SetCommonDataFormat DIFORMAT_KEYBOARD
   DInputDevice.SetCooperativeLevel Form_Val.hWnd, DISCL_NONEXCLUSIVE Or DISCL_BACKGROUND
   DInputDevice.Acquire
   ConnectToKeyboard = True

Exit Function

inierr:
ConnectToKeyboard = False

End Function
Function GetKeyState()

DInputDevice.GetDeviceStateKeyboard KeyboardState
If KeyboardState.Key(DiKeyUp) <> "0" Then
   P_Up = True
Else
   P_Up = False
End If

If KeyboardState.Key(DiKeyDown) <> "0" Then
   P_Down = True
Else
   P_Down = False
End If

If KeyboardState.Key(DiKeyLeft) <> "0" Then
   P_Left = True
Else
   P_Left = False
End If

If KeyboardState.Key(DiKeyRight) <> "0" Then
   P_Right = True
Else
   P_Right = False
End If

End Function
Public Property Get Key_Up() As Boolean
   Key_Up = P_Up
End Property
Public Property Let Key_Up(ByVal vNewValue As Boolean)
End Property
Public Property Get Key_Down() As Boolean
   Key_Down = P_Down
End Property
Public Property Let Key_Down(ByVal vNewValue As Boolean)
End Property
Public Property Get Key_Left() As Boolean
   Key_Left = P_Left
End Property
Public Property Let Key_Left(ByVal vNewValue As Boolean)
End Property
Public Property Get Key_Right() As Boolean
   Key_Right = P_Right
End Property
Public Property Let Key_Right(ByVal vNewValue As Boolean)
End Property

